.8086
;---------------------------------------------------------------------------
;    CBUSLDR.S  C-BUS boot ROM loader (C)2025 ܂(DOSsoft) Version 4.90
;---------------------------------------------------------------------------
DIV0_ENABLE     equ     1
CBUS_BD_ID      equ     1Dh

code            segment
                assume cs:code,ds:code,es:code,ss:code
                org    0
start:          db      0CBh, 90h, 90h
                db      0CBh, 90h, 90h
                db      0CBh, 90h, 90h  ;                       ** bx bx+1
                db       55h,0AAh, CBUS_BD_ID ; C BUS ROM ID =  1D,DD,9D
                org  0Ch
                JMP     ROM_entry1
                nop
                org  0Fh
                db      0CBh, 90h, 90h
                org  12h
                db      0CBh, 90h, 90h
                org  15h
                db      0CBh, 90h, 90h, 0CBh, 90h, 90h, 0CBh, 90h, 90h
                db      0CBh, 90h, 90h, 0CBh, 90h, 90h, 0CBh, 90h, 90h
                db      0CBh, 90h, 90h, 0CBh, 90h, 90h, 0CBh, 90h, 90h
.386

ROM_entry1:     mov     byte ptr ds:[bx],(CBUS_BD_ID or 0C0h) ; ROM pruducts and type
                pushf
                pushad
                push    ds
                push    es
ifdef   DIV0_ENABLE
                xor     ax,ax
                mov     es,ax
                mov     word ptr es:[0],offset Div0Recover
                mov     word ptr es:[2],cs
endif
                mov     es,cs:seg_position
                mov     si,offset COM_PROGRAM_START
                mov     di,00F8h        ; DS:SI --> 7000(ES):00F0h
                mov     ax,cs
                stosw   ;       [F8h]=cs,[FAh]=ds
                mov     ax,ds
                stosw
                mov     ax,01E8h
                stosw
                mov     ax,0CB00h  ;  CALL 100, RETF ߃R[h
                stosw

                push    cs
                pop     ds              ; ds=cs, es=7000h
                mov     cx,1000h        ; 8KB ROM = 2000h, 4KB=1000h
                sub     cx, offset COM_PROGRAM_START    ;(7000h)
        rep     movsb                   ; cs --> es
;;;             mov     es:[00F4h],ds   ; save the original values.
;;;             mov     es:[00F6h],es   ;   of the segment register.
  
;;;;--------- stack switcher -----
                mov     es:[00F0h],ss   ; stack pointer
                mov     es:[00F2h],sp
                cli
                mov     ax,es           ; es=7000h
                mov     ds,ax           ; ds=7000h (new segment)
                mov     ss,ax
                mov     sp,0FF00h       ; save stack pointer
                sti

                ;   call far [7000:00FC]
                DB      9Ah
ofs_position    DW      00FCh
seg_position    DW      7000h           ; 7000h -

                cli
                mov     es,cs:seg_position      ; es=7000h (original segment)
                mov     sp,es:[00F2h]   ; restore stack pointer
                mov     ss,es:[00F0h]
                sti

                pop     es
                pop     ds
                popad
                popf
                RETF

ifdef   DIV0_ENABLE
Div0Recover:    
                pop     ax
                inc     ax
                inc     ax
                push    ax
                
                push    bx
                push    cx
                push    si
                push    di
                pushf
                mov     si,offset div0mes
                mov     cx,offset div0mes_e - offset div0mes
                call    DisplayVRAM
                popf
                pop     di
                pop     si
                pop     cx
                pop     bx

                mov     dx,0000h
                mov     ax,0FFFFh
                IRET

;;;ueʏ𒴂fBXNhCuڑĂ܂v
div0mes         label   byte
DW      462Dh,46ADh,4C2Eh,4CAEh,651Eh,659Eh,4218h,4298h,7204h,7284h,3624h
DW      36A4h,2804h,2884h,3F04h,3F84h,4705h,4785h,2305h,2385h,3905h,3985h
DW      2F05h,2F85h,4905h,4985h,6905h,6985h,2405h,2485h,5605h,5685h,2C04h
DW      2C84h,5C20h,5CA0h,3322h,33A2h,3504h,3584h,6C04h,6C84h,4604h,4684h
DW      2404h,2484h,5E04h,5E84h,3904h,3984h
div0mes_e       label   byte

;---------------------------------------------------------------------
;   DisplayVRAM   cs:si=string pointer,  cx=length, color attribute
;---------------------------------------------------------------------
DisplayVRAM     PROC   near     ; DI=position on T-VRAM
                push    es
                cld
                shr     cx,1
                xor     ax,ax   ; 
                mov     es,ax
                mov     ah,0E0h
                test    byte ptr es:[0501h],8
                jnz     @f
                mov     ah,0A0h
        @@:     
                mov     es,ax
                mov     di,(2*30)+(2*80*24) ; column locatin
DispVramEnt:    mov     ax,cs:[si]
                inc     si
                inc     si
                mov     byte ptr es:[di+2000h],61h        ; VRAM attribute write
                stosw
               loop     DispVramEnt
                pop     es
                ret
DisplayVRAM     ENDP

ENDIF

                DB      0,0,"CBLDR",0

COM_PROGRAM_START       label   byte

code    ends
        end     start
