;;;INICOM equ 1
;----------------------------------------------------------------------------
; PC-9821B2 IDE BIOS patch Version 5.20 (C) 2024-2025 ܂
;----------------------------------------------------------------------------
MEMseg          equ     6800h   ; < 8000h
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit(X-mateł͗v)  
SND_equip       equ     80h     ; SND BIOS bit(A-mate,FELLOW)

LOCATION_CHSLBA equ     1D70h   ; Ƃ̂Ɏ܂ȂR[h̊i[ꏊ
LOCATION_LBACHS equ     10F0h   ; ubNXgׂĂ
LOCATION_IDP    equ     1E65h   ; IDE BIOS̋󂫂͎gȂ悤ɂ
LOCATION_FUNC84 equ     10B7h   ; 
LOCATION_CAPA   equ     1DB0h   ; Ƃ̂Ɏ܂ȂR[h̊i[ꏊ
LOCATION_SET66  equ     1FB0h
MSG_DISP_LINE   equ     13      ; \JnsłBKXĂB
; Global stack variables -----------------
SegTVRAM        equ     word ptr [bp-4] ; T-VRAM̃ZOgA000/E000
ROW             equ     word ptr [bp-6] ; \s
COLUMN          equ     word ptr [bp-8] ; \J
COLOR_ATTRIB    equ     byte ptr [bp-10] ; \F
HiresoFlag      equ     byte ptr [bp-11] ; 01h Hi-reso flag (bit 0)
StartLine       equ     byte ptr [bp-12] ;

equip           equ     byte ptr [bp-14] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
ModeID          equ     byte ptr [bp-15] ; ݂̃p[^[h
MemWindowAddr   equ     byte ptr [bp-16] ; 08-BANK window address in EXROM
MachineID       equ     byte ptr [bp-17] ; Machine ID
MemWindowNative equ     byte ptr [bp-18] ; 08-BANK window native address
MachineType     equ     byte ptr [bp-19] ; [1]=Ap2/As2/Af, [2]=B2

mem_bank_IOaddr equ     word ptr [bp-22] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-24] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-26] ; IDE BIOSZOgiRAMmappingj

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
                org 102h
title_msg       DB      0E1h,"IDE BIOS̗eʏgCHSύXmANTI-CFؾānIDE BIOS Qp V5.20 ",13,10,0

.186
program_start:  
                mov     dx,1E8Eh
                mov     al,81h
                out     dx,al
                
                enter   36,0
                mov     COLOR_ATTRIB,0E1h
                cld
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
                xor     ax,ax           ; AL=0
                mov     equip,al        ; bit̏l
                mov     MachineType,al  ; =0
                
                call    GetSeg_IDEBIOS  ; ^,RAMIDE BIOSZOg𓾂 2018-12-11V
                call    ModelCheckAB2   ; @풲, B2,C2ȊO͒~(A2́H)
                pushf   ; CYtOză^Cg\Ă
                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                call    DisplayTitle    ; ^Cg\
                popf
                jc      WrongMachine
                cmp     MachineType,0
                jz      WrongMachine

                call    Scan_GRPH_FK    ; 2025-3-20 dlύX
                jc      CancelCTRL

                call    CheckMemSwitch  ; XCb`̃[hݒ擾
                jc      ExitProgram     ; CY=G[ŏI
                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~

                call    NOPCI_Check     ; PCI BIOS邩HCY
                jc      WrongMachine    ; CYĂ΋@ႢŃG[
                call    PeriEnvCheck    ; 486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~

                call    DisplayEquip
                call    ROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB
                cmp     MachineType,1   ; Ap2,As2
                je      To_A2_pathch
                call    B2_patch        ; B2@̃pb`
                jc      WrongBIOS
                call    SetChkSum
                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
                call    ClearMEMseg     ; ƃNAđދ
ExitProgram:
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~

ifdef   INICOM  ; eXgp
                mov     ax,0380h
                int     1Bh
endif
                call    SetDisplayLine
                leave
                RET    ; near ^[ŏI
;-------------------------------------------
WrongMachine:   mov     dx,offset wrong_msg 
                call    _puts   ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
CancelCTRL:     mov     dx,offset msg_CRLF
                call    _puts
                jmp     AvoidPatch
WrongBIOS:      call    Poop ; ````
                mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
                jmp     ExitProgram
To_A2_pathch:   mov     dx,offset msg_not_for_A2
                call    _puts
                call    Poop ; ````
                jmp     AvoidPatch

;------ Q ------------------------------------------------------
msg_not_for_A2  DB     041h,"PC-9821Ap2,As2,Afɂ͑Ή܂. ",0

;--------------------------------------------------------
;       machines
;--------------------------------------------------------
include patch_b2.s

;------------------------------------------------------------
;       ModelCheckAB2
;------------------------------------------------------------
ModelCheckAB2   PROC   near
                mov     al,MachineID
                cmp     al,07h  ; Bp,Bs,Be,PC-9801 BX2,BA2
                je      Machine_B2
                cmp     al,08h  ; Ce2,Cs2
                je      Machine_C2
                cmp     al,05h ; Ap2,As2      ; <====05 
                je      Machine_A2
                cmp     al,06h ; Af
                je      Machine_A2
                mov     MachineType,0
                stc
                ret
Machine_C2:     mov     MachineType,4   ; 4=Cs2,Ce2
                clc
                ret
Machine_B2:     mov     MachineType,2   ; 2=B2
                clc
                ret
Machine_A2:     mov     MachineType,1   ; Af,Ap2,As2
                clc
                ret
ModelCheckAB2   ENDP

;------------------------------
include memcopy.inc
include ideptcom.inc
include numeric.inc     ; l\[`
include e:\asmlib\putstrCS.inc      ; \[`i\[X͕t܂j
;-----------------------------------------
.386
PatPtn2_LBA_CHS    label word      ; offset 0A66h
                mov     si,2080h
                test    byte ptr [bp+00h],01h
                jz      @f
                mov     si,2090h
        @@:     
                push    ax
                mov     ax,es:[si+0Ah]  ; ZN^ ,wbh
                mul     ah
                mov     cx,ax           ; ZN^*wbh=CX
                pop     ax              ; DX:AX

                div     cx
                mov     es:[2002h],ax
                mov     ax,dx
                mov     cl,es:[si+0Ah]
                mov     ch,0
                mov     dx,0
                RET
PatPtn2_LBA_CHS_end  label word
;--------------------------------------
.186
;--------------------------------------
;  W    [2082h]    CylnN(BIOS,logical)
;  B    [208Ah]    SectN(device,physical)
;  B    [208Bh]    HeadN(device,physical)
;          9
;  B    [208Eh]    SectN(BIOS,logical)
;  B    [208Fh]    HeadN(BIOS,logical)

PatPtn2_IDP     label word      ; offset 1DC0
                test    byte ptr [bp+00h],01h
                jz      Drive00
Drive01:        mov     byte ptr ah,es:[2090h+0Bh]
                dec     ah      ;phys head-1
                and     al,07h
                cmp     al,04h
                jmp     LAB_39A
Drive00:        mov     byte ptr ah,es:[2080h+0Bh]
                dec     ah      ;phys head-1
                and     al,38h
                cmp     al,20h
LAB_39A:
                jnz     LAB_3A5
                or      byte ptr es:[2004h],ah
                jmp     LAB_3AB
                nop
LAB_3A5:
                or      byte ptr es:[2004h],ah
LAB_3AB:
                RET
PatPtn2_IDP_end  label word
;----------------------------------
PatPtn2_Func84  label word      ; offset 03E1h
                push    ax
                mov     si,2080h
                test    byte ptr [bp+00],01h
                jz      @f
                mov     si,2090h
        @@:
                mov     al,es:[si+0Eh]  ; S
                mov     [bp+06h],al
                mov     al,es:[si+0Fh]  ; H
                mov     [bp+07h],al
                mov     dx,es:[si+02h]  ; C
                mov     [bp+04h],dx
                pop     ax
                ret
PatPtn2_Func84_end  label word

;----------------------------------
DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0
DB      "ROM̕ւ܂. (C)2025",0,0
code    ends
        end     start
